/* Express Js*/
var express = require('express');

/* Crypto Library */
var crypto = require('crypto');

var moment = require('moment');
/* Encryption Algorithym */
var algorithym = 'sha256';
/* Encryption Key*/
var secret = 'chavalito';
/* Hash Code Lenght*/
let hashCodeLenght = 64;

var lastHashSended = "";


var flagUdpFromServer = 'herecomestheperculaes';

var boatUdpPacket;
var droneUdpPacket;


/* Provides info about device */
var os = require('os');

var ifaces = os.networkInterfaces();

/* Router Object For Diferents Url Responses */
var router = express.Router();

/* Google Maps JavaScript API */
var GoogleMapsAPI = require('googlemaps');

/* JSON reader --> Not Sure If needed*/
var fs = require('fs');

/* Dgram UDP socket library */
const dgram = require('dgram');

/* Google Maps JavaScript API Key*/
var googleMapsApiKey = 'AIzaSyDIfvxlM3NHU6mUMvIL0QPQp5jKeAjU0po';

/* UDP Socket */
/* Type: udp4 (ipv4)*/ /* change to udp6 if using ipv6 */
/* reuseAddr : socket will reuse address even if other process is bound to it */
const socket = dgram.createSocket({type: 'udp4', reuseAddr: true});

var publicConfig = {
	key: googleMapsApiKey,
	stagger_time:       1000,
	encode_polylines:   false,
  //secure:             true, // use https
  //proxy:              'http://127.0.0.1:9999' // optional, set a proxy for HTTP requests
};

/* Config for the Google Maps API */
var gmAPI = new GoogleMapsAPI(publicConfig);

/*-----------------------*/
/*     ROUTER EVENTS     */
/*-----------------------*/

/* GET Google Maps */
router.get('/map',function(req,res,next){
	res.render('map',{mapKey: googleMapsApiKey});
});

/* AJAX --> UDP Datagram */
router.get('/api/getBoatUdpPacket',function (req,res,next) {
	res.send(boatUdpPacket);
	console.table(boatUdpPacket);

});
router.get('/api/getDroneUdpPacket',function (req,res,next) {
	res.send(droneUdpPacket);
	console.log(droneUdpPacket);

});

/*----------------------*/
/*    SOCKET EVENTS     */
/*----------------------*/

socket.on('listening', () => {
	let addr = socket.address();
	console.log('Listening for UDP packets at');
});

socket.on('error', (err) => {
	console.error('UDP error: '+ err.stack);
});

socket.on('message', (msg, info) => {

	/* Udp Packet to String */
	let udpToString = msg.toString();
	/* Node JS timestamp with python format */
	let timestamp = moment().format("MM/DD/YYYY, HH:mm:ss");
	/* Extracted Hash from Packet */
	let udpHash = getHashFromJson(udpToString,hashCodeLenght)[1];
	/* Extracted Json from Packet */
	let jsonFromUdp = getHashFromJson(udpToString,hashCodeLenght)[0];
	/* Hash Generated By The Server */
	let serverHash = createOwnHash(udpToString,secret);
	/* Date From Udp */
	let dateFromUdp = getHashFromJson(jsonFromUdp,22)[1];
	dateFromUdp = dateFromUdp.slice(0, dateFromUdp.length-2);

	parsedJson = jsonFromUdp;

	parsedJson = JSON.parse(parsedJson);

	if(serverHash == udpHash && dateFromUdp.slice(0, - 3) == timestamp.slice(0, - 3)){ /* we accept the message*/
		if(parsedJson.type == "boat"){
			boatUdpPacket = parsedJson;
		}else if(parsedJson.type == "drone"){
			droneUdpPacket = parsedJson;
		}
		lastHashSended = serverHash;
	}else if(lastHashSended = serverHash){
		udpPacket = "";
	}
});

router.all('/*',function (req, res, next) {
	res.redirect('/map');
});


/* Status: OK */
/* Encrypts the parameter and return it */
/* createCipher and createDechyper is deprecated*/
function encrypt(raw){

	/* Creating Key */
	const cipher = crypto.createCipher(algorithym,password);
	/* Ecrypting Content */
	let encrypted = cipher.update(raw, 'utf8', 'hex');

	encrypted += cipher.final('hex');

	return encrypted;
}

/**/
function decrypt(raw){

	/* Creating Decrypt Key */
	const decipher = crypto.createDecipher(algorithym,secret);
	/* Decrypting Text */
	let decrypted = decipher.update(raw, 'hex', 'utf8');

}

function createHash(algorithym = sha256,text){

	let textToHash = text;

	const hash = crypto.createHash('sha256');
	hash.update(textToHash);
	

	return hash.digest('hex');

}

/*[0] JSON --> characters before bit wall*/
/*[1] HASH --> characters after bit wall*/
/* You are reciving a string, also returns the secret */
function getHashFromJson(json,characters){

	let toReturn = [];
	let jsonToString = json.toString();

	toReturn[0] = jsonToString.slice(0,-characters);
	toReturn[1] = jsonToString.substr(jsonToString.length -characters);

	return toReturn;

}

function createOwnHash(json,password){

	let toHash = getHashFromJson(json,hashCodeLenght);

	return createHash('sha256',toHash[0]+password);

}

/* Udp Socket Binded to host ( UDPSENDER --> APP HOST --> Node Js Server ) */
/* UDP SOCKET BIND*/

socket.bind(63577,'127.0.0.1',function (argument) {
	console.log('connected');

});


module.exports = router;

(function loop(){
	setTimeout(function(){

		let actualTimestamp = moment().format("MM/DD/YYYY, HH:mm:ss").slice(0,-1);

		if(boatUdpPacket != undefined){
			let udptimeStamp = boatUdpPacket.timestamp.slice(0,-1);
			if(actualTimestamp != udptimeStamp){
				boatUdpPacket = undefined;
			}
		}

		if(droneUdpPacket != undefined){
			udptimeStamp = droneUdpPacket.timestamp.slice(0,1);
			if(actualTimestamp != udptimeStamp){
				droneUdpPacket = undefined;
			}
		}
		loop();
	},3000)
}())
